#include <stdio.h>
#include <stdlib.h>

#define WIDTH      32
#define HEIGHT     16
#define BORDER     1
#define SIZE       ((HEIGHT+BORDER*2)*(WIDTH+BORDER*2))
#define IX(i,j)    ((i)+(WIDTH+BORDER*2)*(j))

unsigned char p[SIZE];

void print_array()
{
	int i,j;
	for (j=0; j<HEIGHT+BORDER*2; j++) {
		for (i=0; i<WIDTH+BORDER*2; i++) {
			printf("%X ", p[IX(i,j)]);
		}
		printf("\n");
	}
	printf("\n");
	getchar();
}

#define GS_NUM_LOOPS 3

__inline void diag(int i)
{
	int j;
	int end;
	if (i<WIDTH) {
		end = (i>=HEIGHT) ? end=i-HEIGHT+1 : 0;
		for (j=i; j>=end; --j) {
			int x = BORDER+j;
			int y = BORDER+i-j;
			p[IX(x,y)] += 1;
		}
	} else if (i<WIDTH+HEIGHT) {
		int y_off = i-WIDTH;
		for (j=WIDTH+HEIGHT-i-1; j>0; --j) {
			int x = BORDER+WIDTH-j;
			int y = BORDER+y_off+j;
			p[IX(x,y)] += 1;
		}
	}
}

int main()
{
	int i,j,k,m;

	memset(p, 0, SIZE);

	#if 0
	diag(10);
	print_array();
	diag(HEIGHT+1);
	print_array();
	diag(WIDTH+1);
	print_array();
	#endif

	#if 1
	for (m=0; m<WIDTH+HEIGHT+GS_NUM_LOOPS; ++m) {
		int end=m;
		int start=m-GS_NUM_LOOPS;
		if (start<0) {
			start=0;
		}
		if (end>=WIDTH+HEIGHT) {
			end=WIDTH+HEIGHT-1;
		}
		for (k=end; k>m-GS_NUM_LOOPS; --k) {
			diag(k);
			print_array();
		}
	}
	#endif

	#if 0
	/* calculate upper triangle */
	printf("-- upper triangle --\n");
	for (m=0; m<WIDTH+1; ++m) {
		//printf("m=%d\n",m);
		int end   = (m<WIDTH) ? end = m : WIDTH;
		int start = (end<GS_NUM_LOOPS) ? 0: end-GS_NUM_LOOPS+1;
		for (k=end; k>=start; --k) {
			int k2;
			for (k2=(k>=HEIGHT) ? HEIGHT-1 : k; k2>=0; --k2) {
				int x = BORDER+k-k2;
				int y = BORDER+k2;
				p[IX(x,y)] += 1;
			}
			//printf("start=%d, end=%d, k=%d, k2=%d\n", start, end, k, k2);
			//print_array();
		}
	}
	#endif
	#if 0
	printf("-- lower triangle --\n");
	for (m=0; m<HEIGHT+GS_NUM_LOOPS-1; ++m) {
		//printf("m=%d\n",m);
		int back = m-GS_NUM_LOOPS;
		if (back<0) {
			back=0;
		}
		for (k=m; k>back; --k) {
			int y_off = k;
			int k2;
			for (k2=HEIGHT-1-y_off; k2>=0; --k2) {
				int x = BORDER+WIDTH-1-k2;
				int y = BORDER+y_off+k2;
				p[IX(x,y)] += 1;
			}
			printf("m=%d, k=%d, k2=%d\n", m, k, k2);
			print_array();
		}
	}
	#endif
	#if 0
	printf("-- upper triangle --\n");
	for (m=0; m<GS_NUM_LOOPS; ++m) {
		//printf("m=%d\n",m);
		for (k=m; k>=0; --k) {
			int k2;
			for (k2=k; k2>=0; --k2) {
				int x = BORDER+k-k2;
				int y = BORDER+k2;
				p[IX(x,y)] += 1;
			}
			print_array();
		}
	}
	#endif
	/* calculate the other diagonals */

	return 0;
}
