#define WIDTH      160
#define HEIGHT     80
#define BORDER     1
#define SIZE       ((HEIGHT+BORDER*2)*(WIDTH+BORDER*2))
#define IX(i,j)    ((i)+(WIDTH+BORDER*2)*(j))
#define SWAP(x0,x) {freal *tmp=x0;x0=x;x=tmp;}
#define FIXEDPOINT 1

#if FIXEDPOINT
  /* fixed point implementation */
  typedef long freal;
# define HALVE(x) ( (freal) ((x)>>1) )
# define FPP 19 //13 for long ,19 for longlong
# define X1_0    (1<<FPP)
# define I2X(x)  ( (freal) ( (x)<<FPP ) )
# define F2X(x)  ( (freal) ( (x) * X1_0 ) )
# define X2I(x)  ( (int)   ( (x)>>FPP ) )
# define X2F(x)  ( ( (float) (x) )/X1_0 )
# define XM(x,y) ( (freal) (XML(x,y)>>FPP) )
# define XD(x,y) ( (freal) ( ((x)<<FPP)/(y) ) )
# define XML(x,y) ( (long long) (x) * (y) )
# define XDL(x,y) ( ((long long) (x) <<FPP)/(y) )
#else
  /* floating point implementation */
  typedef float freal;
# define HALVE(x) ( (freal) (0.5*(x)) )
# define X1_0    1.0
# define I2X(x)  ( (freal) (x) )
# define F2X(x)  ( (freal) (x) )
# define X2I(x)  ( (int)   (x) )
# define X2F(x)  ( (float) (x) )
# define XM(x,y) ( (freal) (x)*(y) )
# define XD(x,y) ( (freal) ( (x)/(y) ) )
# define XML(x,y) ( (freal) (x)*(y) )
# define XDL(x,y) ( (freal) (x)/(y) )
#endif

void add_source(freal *x, freal *s, freal dt);

void model_set_bnd_rout(void *func);

void diffuse_bad(int b, freal *x, freal *x0, freal diff, freal dt);

void diffuse(int b, freal *x, freal *x0, freal diff, freal dt);

void diffuse_fixed(int b, freal *x, freal *x0, freal diff, freal dt);

void advect(int b, freal *d, freal *d0, freal *u, freal *v, freal dt);

void dens_step(freal *x, freal *x0, freal *u, freal *v, freal diff, freal dt);

void project(freal *u, freal *v, freal *u0, freal *v0, int gs_loops);

void vel_step(freal *u, freal *v, freal *u0, freal *v0, freal visc, freal dt);


